/*
    dltrace v0.5
    Copyright (C) 2005 Richard Johnson <rjohnson@idefense.com>

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation; either version 2 of the License, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    this program; if not, write to the Free Software Foundation, Inc., 59 Temple
    Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef __LISTS_H
#define __LISTS_H

typedef struct splay_s {
	struct splay_s	*left;
	struct splay_s	*right;
	void		*key;
	void 		*data;
} splay_t;

extern splay_t *splay_init(void);
extern void *splay_find(splay_t **tree, void *key,
	int (*key_cmp)(void *, void *));
extern int splay_insert(splay_t **tree, void *key, void *data,
	int (*key_cmp)(void *, void *));
extern splay_t *splay_delete(splay_t **tree, void *key,
	int (*key_cmp)(void *, void *));

typedef struct ll_node {
	struct ll_node *next;
	void *data;
} list_t;


extern int list_push (list_t **node, void *data);
extern int list_append (list_t **node, void *data);
extern list_t *list_pop(list_t **node);

#endif /* __LISTS_H */
